const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ExpensesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expenses = await db.expenses.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        category: data.category || null,
        amount: data.amount || null,
        date: data.date || null,
        note: data.note || null,
        attachment_url: data.attachment_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await expenses.setTenant(data.tenant || null, {
      transaction,
    });

    await expenses.setVehicle(data.vehicle || null, {
      transaction,
    });

    await expenses.setAgences(data.agences || null, {
      transaction,
    });

    return expenses;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const expensesData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      category: item.category || null,
      amount: item.amount || null,
      date: item.date || null,
      note: item.note || null,
      attachment_url: item.attachment_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const expenses = await db.expenses.bulkCreate(expensesData, {
      transaction,
    });

    // For each item created, replace relation files

    return expenses;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const expenses = await db.expenses.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.category !== undefined) updatePayload.category = data.category;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.date !== undefined) updatePayload.date = data.date;

    if (data.note !== undefined) updatePayload.note = data.note;

    if (data.attachment_url !== undefined)
      updatePayload.attachment_url = data.attachment_url;

    updatePayload.updatedById = currentUser.id;

    await expenses.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await expenses.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.vehicle !== undefined) {
      await expenses.setVehicle(
        data.vehicle,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await expenses.setAgences(
        data.agences,

        { transaction },
      );
    }

    return expenses;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expenses = await db.expenses.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of expenses) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of expenses) {
        await record.destroy({ transaction });
      }
    });

    return expenses;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expenses = await db.expenses.findByPk(id, options);

    await expenses.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await expenses.destroy({
      transaction,
    });

    return expenses;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const expenses = await db.expenses.findOne({ where }, { transaction });

    if (!expenses) {
      return expenses;
    }

    const output = expenses.get({ plain: true });

    output.tenant = await expenses.getTenant({
      transaction,
    });

    output.vehicle = await expenses.getVehicle({
      transaction,
    });

    output.agences = await expenses.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.vehicles,
        as: 'vehicle',

        where: filter.vehicle
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.vehicle
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  plate_number: {
                    [Op.or]: filter.vehicle
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.category) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('expenses', 'category', filter.category),
        };
      }

      if (filter.note) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('expenses', 'note', filter.note),
        };
      }

      if (filter.attachment_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'expenses',
            'attachment_url',
            filter.attachment_url,
          ),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.dateRange) {
        const [start, end] = filter.dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.expenses.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('expenses', 'category', query),
        ],
      };
    }

    const records = await db.expenses.findAll({
      attributes: ['id', 'category'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['category', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.category,
    }));
  }
};
